
// ******************************* Programmbeispiele    Versuch 2   2015 **************************

// *************************** OHNE Optimierung bersetzen **********************************

//							******** P R O G R A M M B E I S P I E L E ***********


//  ***** PROGRAMMBEISPIEL 01 ******

//  Einen Text ausgeben =  eine Zeichenkette ber die serielle Schnittstelle senden

sg[0]=0xc0;						// Siebensegmentanzeige mit Werten fllen
sg[1]=0xf9;						
sg[2]=0xa4;
sg[3]=0xb0;
sg[4]=0x99;
sg[5]=0x92;
sg[6]=0x82;
sg[7]=0xf8;
sg[8]=0x80;
sg[9]=0x90;

						// Ab hier geht's los

uint8_t q;						// Hilfsvariable

char stringbuffer[100];			// Array fr Zeichenausgabe


//							******* Hierher kommt die Initialisierung *********


usart_init();					// Die UART initialisieren

asm volatile("sei"::);			// Interrupts zulassen. Das geht nur mit einem Assemblerbefehl.
								// da dessen Syntax so schauders aussieht, dafr knnen wir nichts...


				// Jetzt wird die Zeichenkette eingerichtet und gesendet
								
strcpy (stringbuffer, "Hello, World"); // Begrungstext


for (q=0; q<=strlen(stringbuffer); q++) // Den Text senden
senden (stringbuffer[q]);
	
								
while (1)						// Die allgemeine Endlosschleife
{





}



//  ***** PROGRAMMBEISPIEL 02 ******

//  Verschnerung: Den Cursor an den Anfang der nchsten Zeile setzen


strcpy (stringbuffer, "Hello, World"); // Begrungstext


for (q=0; q<=strlen(stringbuffer); q++) // Den Text senden
senden (stringbuffer[q]);

senden (CR);							// Wir senden zustzlich Wagenrcklauf und Zeilenschaltung;
senden (LF);


// 					Hier knnen Sie weitere Texte nach eigener Wahl senden (ausprobieren...)




//  ***** PROGRAMMBEISPIEL 03 ******

//  Echofunktionen. Wir bauen die Interruptserviceroutine (ISR) um


ISR(USART_RXC_vect)				// Mu so heien
{

received_byte = UDR;			// Das Byte abholen

senden (received_byte);			// Zurcksenden (Echo)

switch (received_byte)
{

	case CR:
	{
	 	senden (LF); 			// CR behandeln
		break;					// zustzlich LF senden (Zeilenvorschub)
	}

 	case BS: 					// BACKSPACE behandeln
	{
		senden (SP);			// Das aktuelle Byte lschen 
		senden (BS);			// zum aktuellen Byte zurck		
		break;
	}

}

}



//  ***** PROGRAMMBEISPIEL 04 ******

//  Die LCD-Anzeige initalisieren und erproben


// Diese Definitionen kommen an den Anfang (nach den Includes):

#define function_set 	0b00111000		// Das sind Initialsierungskommandos
#define	clear_display 	0b00000001
#define onoffctl		0b00001111
#define entry_mode		0b00000110
#define lcd_shift 		0b00011000
#define lcd_row1 		0x80			// An den Anfang der ersten Zeile
#define lcd_row2 		0xc0			// An den Anfang der zweiten zeile
				

				//  ***** Jetzt sind die elementaren Kommandofunktionen einzubauen 

					// Die Signalfolgen werden ganz elementar ausprogrammiert

void lcd_kdo (uint8_t command)			// Ein LCD-Kommando ausfhren
{

	PORTB = 0b00000000;					// Kommandobertragung. RS = 0					
	PORTC = command;					// Das Kommando auf den Bus
	PORTB = 0b00000100;					// Der E-Impuls: Bit ein...
	PORTB = 0b00000000;					//				und wieder aus
	lcdtime();							// Die Ausfhrungszeit abwarten					
}


void lcd_dat (uint8_t data)				// Ein Datenbyte bertragen
{
	PORTB = 0b00000001;					// Datenbertragung. RS = 1
	PORTC = data;						// Das Datenbyte auf den Bus
	PORTB = 0b00000101;					// Der E-Impuls
	PORTB = 0b00000001;
	lcdtime();							// Die Ausfhrungszeit abwarten	
}


void lcd_lkdo (uint8_t command)			// Ein LCD-Kommand ausfhren, das lnger dauert
{
PORTB = 0b00000000;
PORTC = command;
PORTB = 0b00000100;
PORTB = 0b00000000;
millisecs(2);							// 2 ms Ausfhrungszeit abwarten
}


void lcdtime (void)						// Die normale Ausfhrungszeit abwarten
{										// Es sind mindestens 40 s

	uint16_t x;
	x= 10;

	while (x) x-- ;

return ;
}

				// ****** Das ist die Initialisierung  

				// Das kommt alles noch vor die Endlosschleife (While (1))

lcd_lkdo (function_set);
millisecs (40);
lcd_lkdo (function_set);
millisecs (20);
lcd_lkdo (function_set);
millisecs (10);

lcd_lkdo (function_set);
lcd_lkdo (clear_display);
lcd_kdo (onoffctl);
lcd_kdo (entry_mode);


			// ****** Jetzt senden wir das Probezeichen:

lcd_dat (0x41);




//  ***** PROGRAMMBEISPIEL 05 ******

//  Eine Zeichenkette zur LCD-Anzeige senden


//					***** Damit ersetzen wir das Senden des Probezeichens


strcpy (stringbuffer, "Borussia Dortmund");
for (q=0; q<strlen(stringbuffer); q++) 	// Den Text senden
lcd_dat (stringbuffer[q]);



//  ***** PROGRAMMBEISPIEL 06 ******

//  Zwei Zeichenketten zur LCD-Anzeige senden


strcpy (stringbuffer, "Borussia Dortmund");
for (q=0; q<strlen(stringbuffer); q++) 	// Den Text senden
lcd_dat (stringbuffer[q]);

lcd_kdo(lcd_row2);			// Die Zeilenschaltung geht nicht von allein.
							// Wir brauchen ein Adrekommando

strcpy (stringbuffer, "Schalke Nullvier"); // Begrungstext
for (q=0; q<strlen(stringbuffer); q++) // Den Text senden
lcd_dat (stringbuffer[q]);


//  ***** PROGRAMMBEISPIEL 07 ******

//  Die Anzeige zyklisch umlaufen lassen (Laufschrift)

//  Die Textdarstellung bleibt, wie sie ist

//  Das Verschiebekommando kommt in die Endlosschleife

								
while (1)						// Die allgemeine Endlosschleife
{

lcd_kdo (lcd_shift);
millisecs (300);


}

// Jede umlaufende Zeile ist 40 Zeichen lang.
// Sie knnen die Anzeigetexte so ndern, da ansehnliche Laufschriftanzeigen herauskommen... 


//  ***** PROGRAMMBEISPIEL 08 ******

// Die LCD-Anzeige von der seriellen Schnittstelle aus untersttzen

// Empfangene Daten werden auch auf dem LCD angezeigt

// Zunchst ganz einfach -- ohne CR und BS. Wir bauen die ISR um.


ISR(USART_RXC_vect)				// Mu so heien
{

received_byte = UDR;			// Das Byte abholen

senden (received_byte);			// Zurcksenden (Echo)

switch (received_byte)
{

	case CR:
	{
	 	senden (LF); 			// CR behandeln
		break;					// zustzlich LF senden (Zeilenvorschub)
	}

 	case BS: 					// BACKSPACE behandeln
	{
		senden (SP);			// Das aktuelle Byte lschen 
		senden (BS);			// zum aktuellen Byte zurck		
		break;
	}

	default:
	lcd_dat (received_byte);	// alle Bytes auer CR und BS zum LCD bertragen
}

}

// 			Das Senden der zeichenkettem mu raus.
//			Die Laufschriftfunktion mu raus:

while (1)						// Die allgemeine Endlosschleife
{


}

// Am Anfang mu die Anzeige leer sein, und der Cursor mu oben links stehen.
// Zur Probe ber das Terminal einen kurzen Text eingeben.




//  ***** PROGRAMMBEISPIEL 09 ******

// Erweiterung der Anzeigeuntersttzung (1). Wrap Around bei Zeilenende.

// Hierzu schreiben wir eine Zeichenausgabefunktion ENTER, 
// die das Zeilenende erkennt und bercksichtigt

// Ganz oben brauchen wir zwei neue globale Variable zur Adrezhlung

uint8_t x, y;							// Adresse in der Zeile und Zeilenadresse


void enter (uint8_t character)
{

	lcd_dat (character);				// das Zeichen ausgeben

	x++;								// die Zeilenadresse erhhen
	if (x==16)							//  die 16. Position wurde berschritten
		{x=0;							// An den Anfang der neuen Zeile
		if (y==1) {y=0; lcd_kdo (lcd_row1); }
		else {y=1; lcd_kdo (lcd_row2);}
		}								// Die Zeilenschaltung ist hier ganz primitiv gelst.
										// Das klappt deshalb, weil es nur zwei Zeilen sind
}



// Jetzt bauen wir noch die ENTER-Funktion in die ISR ein



ISR(USART_RXC_vect)				// Mu so heien
{

received_byte = UDR;			// Das Byte abholen

senden (received_byte);			// Zurcksenden (Echo)

switch (received_byte)
{

	case CR:
	{
	 	senden (LF); 			// CR behandeln
		break;					// zustzlich LF senden (Zeilenvorschub)
	}

 	case BS: 					// BACKSPACE behandeln
	{
		senden (SP);			// Das aktuelle Byte lschen 
		senden (BS);			// zum aktuellen Byte zurck		
		break;
	}

	default:
	enter (received_byte);		// alle Bytes auer CR und BS zum LCD bertragen
}

}

//   Mit dem Terminal ausprobieren...





//  ***** PROGRAMMBEISPIEL 10 ******

// Erweiterung auf Untersttzung der Tasten bzw. Terminalcodes 
// ENTER (CCR) und BACKSPACE (BS)

der Anzeigeuntersttzung (1). Wrap Around bei Zeilenende.

// Hierzu schreiben wir eine Zeichenausgabefunktion ENTER, 
// die das Zeilenende erkennt und bercksichtigt

// Ganz oben brauchen wir zwei neue globale Variable zur Adrezhlung


// Den Rckschritt untersttzen wir mit einer weiteren Funktion:


void backspace ()
{

	if (x==0)								// Wenn am Zeilenanfang, geht's in die nchste Zeile
		{
		if (y==1) {x=15; y=0; lcd_kdo (lcd_row1+x);}
		else {x=15; y=1; lcd_kdo (lcd_row2+x);}
		}
	else 
		{
		x--;								// sonst geht's eine Position nach links
		if (y==0) lcd_kdo (lcd_row1+x); 
		else lcd_kdo (lcd_row2+x);
		}
}		// Jede neue Adresse mu mit einem Adrekommando zum LCD gemeldet werden.




//  Das alles ist in die ISR einzubauen:


ISR(USART_RXC_vect)				// Interrupthandler zum Empfangen
{

received_byte = UDR;				// Byte abholen

switch (received_byte)
{

	case CR:
	{
	senden (CR);
	senden (LF); 						// CR behandeln

	x=0;
	if (y==1) {y=0; lcd_kdo (lcd_row1);} // Zeilenschaltung im LCD
	else {y=1; lcd_kdo (lcd_row2);}
	break;
	}

	case BS:
	{
	senden (received_byte);			// Zurcksenden (Echo Backspace)
	senden (SP);					// Rckschritt aufs letzte Zeichen, das wird gelscht
	senden (BS);					// Nochmals Rckscritt aufs letzte Zeichen
	
					// Das gleiche nochmals, aber fr das LCD:
	backspace ();					// Rckschritt zum letzten Zeichen	
	enter (SP);						// das Zeichen lschen
	backspace ();					// nochmals Rckschritt zum gelschten Zeichen
	break;
	}


	default:						// Alle anderen Zeichen
	{								
	senden (received_byte);			// Zurcksenden (Echo)
	enter (received_byte);			// Zum LCD senden
	}

}

}


//  ... Ausprobieren ....




//  ***** PROGRAMMBEISPIEL 11 ******

//  Den A-D-Wandler in Betrieb nehmen

// 			 Die E-A-Initialsierung abndern. DAs Analogsignal kommt  ber Port A, Bit 0

PORTA = 0xfe;					// Port A Bit 0 auf Eeingang
PORTB = 0b00000010;				// Das TX-:Signal auf 1
PORTC = 0xff;
PORTD = 0xff;
DDRA  = 0xfe; 					// Port A, Bit 0: Pullup abschalten
DDRB  = 0xff;
DDRC  = 0xff;
DDRD  = 0xff;         



//        Vor dem Eintritt in die Endlosschleife ist der A-D-Wandler einzuschalten

ADMUX=0x20;						// Wir nutzen nur die hherwertigen 8 Bits
ADCSRA=0x86;


while (1)						// Die allgemeine Endlosschleife
{


ADCSRA=0xc6; 					// Die Wandlung starten. Hierzu ist Bit 6 zu setzen
								// Wir zeigen hier die einfachste Lsung berhaupt.


while (!(ADCSRA & 0x10)); 		// Warten, bis die Wandlung fertig ist (Bit 4 = 1)

q=ADCH;							// das gewandelte Byte einlesen

ADCSRA = (ADCSRA | 0x10);		// Die Fertiganzeige zurcksetzen (Schreiben einer Eins)

PORTC = ~q;						// Der binren Wert auf Port C ausgeben (zwecks LED-Anzeige) 

}







//  ***** PROGRAMMBEISPIEL 12 ******

//  Digitalvoltmeter mit LCD-Anzeige


//		Am Anfang des Hauptprogramms eine neue Variable definieren:

uint16_t wert;					// ein 16-Bit_Wort, das den binren Zahlenwert aufnimmt

//        Vor dem Eintritt in die Endlosschleife ist der A-D-Wandler einzuschalten

ADMUX=0x00;						// Wir nutzen jetzt alle 10 Bits
ADCSRA=0x86;



while(1) 						// Die allgemeine Endlosschleife
{

ADCSRA=0xc6; 					// Die Wandlung starten


while (!(ADCSRA & 0x10)); 		// Warten, bis die Wandlung fertig ist (Bit 4 = 1)


q=ADCL;							// Die beiden Datenregister einlesen
wert=ADCH;						// Erst das niederwertige, dann das hherwertige
wert = (wert & 0x03)			// die berschssigen Bits (Don't Cares) ausblenden
wert=wert<<8;					// die hherwertigen Bits ins hherwertige Byte

ADCSRA = (ADCSRA | 0x10);		// Die Fertiganzeige zurcksetzen (Schreiben einer Eins)

wert=wert+q;					// Das niederwertige Byte hinzufgen. Wert enthlt jetzt de komplette Binrzahl

wert=wert*4;					// Das ergibt den skalierten Spannungswert in mV

lcd_kdo (lcd_row1);				// An den Anfang der ersten LCD-Zeile

lcd_dat((wert/1000) +0x30);		// Die Tausenderstelle anzeigen

lcd_dat(0x2c);					// Den Dezimalpunkt anzeigen

wert=wert%1000;

lcd_dat((wert/100) +0x30);		// Die Hunderterstelle anzeigen

wert=wert%100;

lcd_dat(wert/10 +0x30);			// Die Zehnerstelle anzeigen

wert=wert%10;

lcd_dat(wert +0x30);			// Die Einerstelle anzeigen

millisecs (300);				// Etwas warten, damit die Anzeige nicht zu sehr zappelt


} 								



//  Wenn das fertig ist, die Ausgabe auf  die serielle Schnittstelle umstellen.
//  Nur dann ausgeben, wenn sich das Wandlungsergebnis gendert hat.
//  Nach der Zahlenausgabe CR + LF senden (neue Zeile)






//  ***** PROGRAMMBEISPIEL 13 ******

//  Digitalvoltmeter mit Siebensegmentanzeige


// 	Die Initialisierung der LCD und der seriellen Schnittstelle entfernen (lschen oder auskommentieren)


// 	Drei Stellen der Siebensegmentanzeige anschlieen. Wir lassen die Einerstelle weg.
// 	Tausenderstelle an Port D, Hunderterstelle an Port B, Zehnerstelle an Port C.


// Es ist nur die Ausgabe zu ndern:


wert=wert*4;					// Das ergibt den skalierten Spannungswert in mV



PORTD = sg[wert/1000];			// Die Tausenderstelle anzeigen

wert=wert%1000;

PORTB =  sg[wert/100);			// Die Hunderterstelle anzeigen

wert=wert%100;

PORTC = sg[wert/10];			// Die Zehnerstelle anzeigen

