
// ******************************* Musterprogramm Versuch 3   2015 **************************

//								LCD an Port D


#include <avr/io.h>       
#include <stdint.h>
#include <avr/iom16.h>
#include <stdio.h>   
#include <stdlib.h>   
#include <avr/interrupt.h> 
#include <inttypes.h>
#include <string.h>



// Die ASCII Steuerzeichen
#define NUL 0x00
#define CR  0x0d
#define EOT 0x04
#define LF 	0x0a
#define ENQ 0x05
#define BEL 0x07
#define ETB 0x17
#define CAN 0x18
#define ACK 0x06
#define NAK 0x15
#define EM  0x19
#define SOH 0x01
#define NL  0x0a
#define DC1 0x11
#define DC2 0x12
#define BS  0x08
#define SP	0x20

#define function_set 	0b00111000		// Das sind Initialsierungskommandos
#define	clear_display 	0b00000001
#define onoffctl		0b00001111
#define entry_mode		0b00000110
#define lcd_shift 		0b00011000
#define lcd_row1 		0x80			// An den Anfang der ersten Zeile
#define lcd_row2 		0xc0			// An den Anfang der zweiten zeile
				

 
uint8_t n, m, o, p;				// Einige globale Variable auf Vorrat

uint8_t received_byte;


								// ********************  DIE FUNKTIONEN *******************


void milli (void)				// Eine Millisekunde darstellen
{

	uint16_t x;
	x= 207;

	while (x) x-- ;

return ;
}


void millisecs (uint16_t ms) 	// ms Millisekunden darstellen
{

	while (ms)
	{
		milli();
		ms--;
	}

return;
}



// ********************************** Die LCD-Funktionen ****************************


void lcd_kdo (uint8_t command)			// Ein LCD-Kommando ausfhren
{

	PORTD = 0b00000000;					// Kommandobertragung. RS = 0					
	PORTC = command;					// Das Kommando auf den Bus
	PORTD = 0b00000100;					// Der E-Impuls: Bit ein...
	PORTD = 0b00000000;					//				und wieder aus
	lcdtime();							// Die Ausfhrungszeit abwarten					
}


void lcd_dat (uint8_t data)				// Ein Datenbyte bertragen
{
	PORTD = 0b00000001;					// Datenbertragung. RS = 1
	PORTC = data;						// Das Datenbyte auf den Bus
	PORTD = 0b00000101;					// Der E-Impuls
	PORTD = 0b00000001;
	lcdtime();							// Die Ausfhrungszeit abwarten	
}


void lcd_lkdo (uint8_t command)			// Ein LCD-Kommand ausfhren, das lnger dauert
{
PORTD = 0b00000000;
PORTC = command;
PORTD = 0b00000100;
PORTD = 0b00000000;
millisecs(2);							// 2 ms Ausfhrungszeit abwarten
}


void lcdtime (void)						// Die normale Ausfhrungszeit abwarten
{										// Es sind mindestens 40 s

	uint16_t x;
	x= 10;

	while (x) x-- ;

return ;
}



//******************************************************************************************




int main (void) 				// ******************** DAS HAUPTPROGRAMM ******************
{            

uint8_t sg[10];					// Siebensegmentanzeige

PORTA = 0xff;					// Alle Ports auf Ausgang
PORTB = 0xff;
PORTC = 0xff;
PORTD = 0x00;
DDRA  = 0xff; 
DDRB  = 0xff;
DDRC  = 0xff;
DDRD  = 0xff;                


sg[0]=0xc0;						// Siebensegmentanzeige mit Werten fllen
sg[1]=0xf9;						
sg[2]=0xa4;
sg[3]=0xb0;
sg[4]=0x99;
sg[5]=0x92;
sg[6]=0x82;
sg[7]=0xf8;
sg[8]=0x80;
sg[9]=0x90;


//							******* Hierher kommt die Initialisierung *********

					

				// ****** Die LCD wird intialisiert  

				// Das kommt alles noch vor die Endlosschleife (While (1))

lcd_lkdo (function_set);
millisecs (40);
lcd_lkdo (function_set);
millisecs (20);
lcd_lkdo (function_set);
millisecs (10);

lcd_lkdo (function_set);
lcd_lkdo (clear_display);
lcd_kdo (onoffctl);
lcd_kdo (entry_mode);


			// ****** Jetzt senden wir das Probezeichen:

lcd_dat (0x41);
	
	
	
								
while (1)						// Die allgemeine Endlosschleife
{





}


return 0;
} 								// ******************** DAS ENDE ***********************
